diff --git a/corefreq-cli-json.c b/corefreq-cli-json.c
index 5ace2ed..d01d764 100644
--- a/corefreq-cli-json.c
+++ b/corefreq-cli-json.c
@@ -1228,7 +1228,7 @@ void JsonSysInfo(SHM_STRUCT *Shm, CELL_FUNC OutFunc) {
         {
             json_start_object(&s);
             json_key(&s, "Q");
-            json_literal(&s, "%u", CFlop->Clock.Q);
+            json_literal(&s, "%llu", CFlop->Clock.Q);
             json_key(&s, "R");
             json_literal(&s, "%llu", CFlop->Clock.R);
             json_key(&s, "Hz");
diff --git a/corefreq-cli.c b/corefreq-cli.c
index 723e717..c7631fd 100644
--- a/corefreq-cli.c
+++ b/corefreq-cli.c
@@ -1,4 +1,3 @@
-
 /*
  * CoreFreq
  * Copyright (C) 2015-2018 CYRIL INGENIERIE
diff --git a/corefreqd.c b/corefreqd.c
index 075fbc9..4040b57 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -167,9 +167,10 @@ static void *Core_Cycle(void *arg)
 				     / (Shm->Sleep.Interval * 1000);
 	} else {
 	// Relative Frequency = Relative Ratio x Bus Clock Frequency
-	  CFlip->Relative.Freq = (double)REL_FREQ( Shm->Proc.Boost[BOOST(MAX)],\
-					CFlip->Relative.Ratio,		\
-					Core->Clock, Shm->Sleep.Interval)
+	  CFlip->Relative.Freq=(double)REL_FREQ(Shm->Proc.Boost[BOOST(MAX)], \
+						CFlip->Relative.Ratio,	\
+						Core->Clock,		\
+						Shm->Sleep.Interval)
 				/ (Shm->Sleep.Interval * 1000);
 	}
 
diff --git a/corefreqk.c b/corefreqk.c
index 207b324..69771a4 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -579,8 +579,8 @@ void Compute_Interval(void)
 static void Compute_Clock(void *arg)
 {
 	COMPUTE_ARG *pCompute = (COMPUTE_ARG *) arg;
-	unsigned int ratio = pCompute->Clock.Q;
 	unsigned long long D[2][OCCURRENCES];
+	unsigned int ratio = (unsigned int) pCompute->Clock.Q;
 	unsigned int loop = 0, what = 0, best[2] = {0, 0}, top[2] = {0, 0};
 /*
 	TSC[0] stores the overhead
@@ -4390,7 +4390,7 @@ void Controller_Init(void)
 	if (clock.Hz == 0) {	// Fallback @ 100 MHz
 		clock.Q = 100;
 		clock.R = 0;
-		clock.Hz = 100000000L;
+		clock.Hz = 100000000LLU;
 	}
 
 	if (Proc->Features.Factory.Freq != 0) {
@@ -4398,12 +4398,12 @@ void Controller_Init(void)
 		ratio = Proc->Boost[BOOST(MAX)] = Proc->Features.Factory.Freq
 						/ clock.Q;
 	} else if (ratio > 0) { // Fix factory frequency (MHz)
-		Proc->Features.Factory.Freq = (ratio * clock.Hz) / 1000000L;
+		Proc->Features.Factory.Freq = (ratio * clock.Hz) / 1000000;
 	}
 	Proc->Features.Factory.Clock.Q  = clock.Q;
 	Proc->Features.Factory.Clock.R  = clock.R;
 	Proc->Features.Factory.Clock.Hz = clock.Hz;
-	Proc->Features.Factory.Ratio	= Proc->Features.Factory.Freq * 1000000L
+	Proc->Features.Factory.Ratio	=(Proc->Features.Factory.Freq * 1000000)
 					/ Proc->Features.Factory.Clock.Hz;
 
 	if ((AutoClock & 0b01) && (ratio != 0)) {
@@ -4704,16 +4704,12 @@ void AMD_Core_Counters_Clear(CORE *Core)
 	    : 0;							\
 })
 
-#define Delta_TSC(Core) 						\
+#define Delta_TSC(Core, OVH_TSC)					\
 ({									\
 	Core->Delta.TSC = Core->Counter[1].TSC				\
 			- Core->Counter[0].TSC; 			\
-									\
-	if (AutoClock & 0b10)						\
-		REL_BCLK(Core->Clock,					\
-			Proc->Boost[BOOST(MAX)],			\
-			Core->Delta.TSC,				\
-			Proc->SleepInterval);				\
+	Core->Delta.TSC = Core->Delta.TSC				\
+			-(Core->Counter[1].TSC - OVH_TSC);		\
 })
 
 #define Delta_C0(Core)							\
@@ -4830,10 +4826,12 @@ void AMD_Core_Counters_Clear(CORE *Core)
 			MSR_PKG_C7_RESIDENCY, Proc->Counter[T].PC07);	\
 })
 
-#define Delta_PTSC(Pkg) 						\
+#define Delta_PTSC(Pkg, OVH_TSC)					\
 ({									\
 	Pkg->Delta.PTSC = Pkg->Counter[1].PTSC				\
-			- Pkg->Counter[0].PTSC;				\
+			- Pkg->Counter[0].PTSC; 			\
+	Pkg->Delta.PTSC = Pkg->Delta.PTSC				\
+			-(Pkg->Counter[1].PTSC - OVH_TSC);		\
 })
 
 #define Delta_PC02(Pkg) 						\
@@ -5107,8 +5105,14 @@ void Core_AMD_Family_17h_Temp(CORE *Core)
 
 static enum hrtimer_restart Cycle_GenuineIntel(struct hrtimer *pTimer)
 {
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	unsigned long long OVH_TSC;
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSC64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5120,7 +5124,7 @@ static enum hrtimer_restart Cycle_GenuineIntel(struct hrtimer *pTimer)
 		if (Core->Bind == Proc->Service.Core) {
 			PKG_Counters_Generic(Core, 1);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Save_PTSC(Proc);
 
@@ -5131,7 +5135,7 @@ static enum hrtimer_restart Cycle_GenuineIntel(struct hrtimer *pTimer)
 
 		Delta_C0(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5141,6 +5145,12 @@ static enum hrtimer_restart Cycle_GenuineIntel(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5191,8 +5201,14 @@ static void Stop_GenuineIntel(void *arg)
 
 static enum hrtimer_restart Cycle_AuthenticAMD(struct hrtimer *pTimer)
 {
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	unsigned long long OVH_TSC;
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSC64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5204,7 +5220,7 @@ static enum hrtimer_restart Cycle_AuthenticAMD(struct hrtimer *pTimer)
 		if (Core->Bind == Proc->Service.Core) {
 			PKG_Counters_Generic(Core, 1);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Save_PTSC(Proc);
 
@@ -5213,7 +5229,7 @@ static enum hrtimer_restart Cycle_AuthenticAMD(struct hrtimer *pTimer)
 
 		Delta_C0(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5223,6 +5239,12 @@ static enum hrtimer_restart Cycle_AuthenticAMD(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5271,9 +5293,18 @@ static void Stop_AuthenticAMD(void *arg)
 
 static enum hrtimer_restart Cycle_Core2(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core=(CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	if (!Proc->Features.AdvPower.EDX.Inv_TSC)
+		RDTSC64(OVH_TSC);
+	else
+		RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core=(CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5288,7 +5319,7 @@ static enum hrtimer_restart Cycle_Core2(struct hrtimer *pTimer)
 			RDMSR(PerfStatus, MSR_IA32_PERF_STATUS);
 			Core->Counter[1].VID = PerfStatus.CORE.CurrVID;
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Save_PTSC(Proc);
 
@@ -5301,7 +5332,7 @@ static enum hrtimer_restart Cycle_Core2(struct hrtimer *pTimer)
 
 		Delta_C0(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5313,6 +5344,12 @@ static enum hrtimer_restart Cycle_Core2(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5366,8 +5403,14 @@ static void Stop_Core2(void *arg)
 
 static enum hrtimer_restart Cycle_Nehalem(struct hrtimer *pTimer)
 {
-	unsigned int cpu = smp_processor_id();
-	CORE *Core=(CORE *) KPublic->Core[cpu];
+	unsigned long long OVH_TSC;
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core=(CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5385,7 +5428,7 @@ static enum hrtimer_restart Cycle_Nehalem(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -5414,7 +5457,7 @@ static enum hrtimer_restart Cycle_Nehalem(struct hrtimer *pTimer)
 
 		Delta_C6(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5430,6 +5473,12 @@ static enum hrtimer_restart Cycle_Nehalem(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5500,9 +5549,15 @@ static void Stop_Uncore_Nehalem(void *arg)
 
 static enum hrtimer_restart Cycle_SandyBridge(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5527,7 +5582,7 @@ static enum hrtimer_restart Cycle_SandyBridge(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -5572,7 +5627,7 @@ static enum hrtimer_restart Cycle_SandyBridge(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5590,6 +5645,12 @@ static enum hrtimer_restart Cycle_SandyBridge(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5661,9 +5722,15 @@ static void Stop_Uncore_SandyBridge(void *arg)
 
 static enum hrtimer_restart Cycle_SandyBridge_EP(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5688,7 +5755,7 @@ static enum hrtimer_restart Cycle_SandyBridge_EP(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -5733,7 +5800,7 @@ static enum hrtimer_restart Cycle_SandyBridge_EP(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5751,6 +5818,12 @@ static enum hrtimer_restart Cycle_SandyBridge_EP(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5822,9 +5895,15 @@ static void Stop_Uncore_SandyBridge_EP(void *arg)
 
 static enum hrtimer_restart Cycle_Haswell_ULT(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -5855,7 +5934,7 @@ static enum hrtimer_restart Cycle_Haswell_ULT(struct hrtimer *pTimer)
 
 			Delta_PC10(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -5906,7 +5985,7 @@ static enum hrtimer_restart Cycle_Haswell_ULT(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -5924,6 +6003,12 @@ static enum hrtimer_restart Cycle_Haswell_ULT(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -5997,9 +6082,15 @@ static void Stop_Uncore_Haswell_ULT(void *arg)
 
 static enum hrtimer_restart Cycle_Haswell_EP(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -6024,7 +6115,7 @@ static enum hrtimer_restart Cycle_Haswell_EP(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -6069,7 +6160,7 @@ static enum hrtimer_restart Cycle_Haswell_EP(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -6087,6 +6178,12 @@ static enum hrtimer_restart Cycle_Haswell_EP(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -6170,9 +6267,15 @@ static void Stop_Uncore_Haswell_EP(void *arg)
 
 static enum hrtimer_restart Cycle_Skylake(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -6197,7 +6300,7 @@ static enum hrtimer_restart Cycle_Skylake(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -6246,7 +6349,7 @@ static enum hrtimer_restart Cycle_Skylake(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -6264,6 +6367,12 @@ static enum hrtimer_restart Cycle_Skylake(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -6334,9 +6443,15 @@ static void Stop_Uncore_Skylake(void *arg)
 
 static enum hrtimer_restart Cycle_Skylake_X(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PERF_STATUS PerfStatus = {.value = 0};
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	CORE *Core;
+	unsigned int cpu;
+
+	RDTSCP64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -6358,7 +6473,7 @@ static enum hrtimer_restart Cycle_Skylake_X(struct hrtimer *pTimer)
 
 			Delta_PC07(Proc);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_UNCORE_FC0(Proc);
 
@@ -6406,7 +6521,7 @@ static enum hrtimer_restart Cycle_Skylake_X(struct hrtimer *pTimer)
 
 		Delta_C7(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -6424,6 +6539,12 @@ static enum hrtimer_restart Cycle_Skylake_X(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -6527,7 +6648,7 @@ static enum hrtimer_restart Cycle_AMD_Family_0Fh(struct hrtimer *pTimer)
 		if (Core->Bind == Proc->Service.Core) {
 			PKG_Counters_Generic(Core, 1);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, Proc->Counter[1].PTSC);
 
 			Save_PTSC(Proc);
 
@@ -6538,7 +6659,7 @@ static enum hrtimer_restart Cycle_AMD_Family_0Fh(struct hrtimer *pTimer)
 
 		Delta_C0(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, Core->Counter[1].TSC); // No overhead
 
 		Delta_C1(Core);
 
@@ -6548,6 +6669,12 @@ static enum hrtimer_restart Cycle_AMD_Family_0Fh(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
@@ -6630,11 +6757,17 @@ static void Stop_AMD_Family_10h(void *arg)
 
 static enum hrtimer_restart Cycle_AMD_Family_17h(struct hrtimer *pTimer)
 {
+	unsigned long long OVH_TSC;
 	PSTATESTAT PstateStat;
 	PSTATEDEF PstateDef;
+	CORE *Core;
 	unsigned int pstate;
-	unsigned int cpu = smp_processor_id();
-	CORE *Core = (CORE *) KPublic->Core[cpu];
+	unsigned int cpu;
+
+	RDTSC64(OVH_TSC);
+
+	cpu = smp_processor_id();
+	Core = (CORE *) KPublic->Core[cpu];
 
 	if (BITVAL(KPrivate->Join[cpu]->TSM, MUSTFWD) == 1) {
 		hrtimer_forward(pTimer,
@@ -6651,7 +6784,7 @@ static enum hrtimer_restart Cycle_AMD_Family_17h(struct hrtimer *pTimer)
 
 			PWR_ACCU_AMD_Family_17h(Proc, 1);
 
-			Delta_PTSC(Proc);
+			Delta_PTSC(Proc, OVH_TSC);
 
 			Delta_PWR_ACCU(Proc, PKG);
 
@@ -6677,7 +6810,7 @@ static enum hrtimer_restart Cycle_AMD_Family_17h(struct hrtimer *pTimer)
 
 		Delta_C0(Core);
 
-		Delta_TSC(Core);
+		Delta_TSC(Core, OVH_TSC);
 
 		Delta_C1(Core);
 
@@ -6689,6 +6822,12 @@ static enum hrtimer_restart Cycle_AMD_Family_17h(struct hrtimer *pTimer)
 
 		Save_C1(Core);
 
+		if (AutoClock & 0b10)
+			REL_BCLK(Core->Clock,
+				Proc->Boost[BOOST(MAX)],
+				Core->Delta.TSC,
+				Proc->SleepInterval);
+
 		BITSET(LOCKLESS, Core->Sync.V, 63);
 
 		return(HRTIMER_RESTART);
diff --git a/coretypes.h b/coretypes.h
index e0fdbf3..cb2d50a 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.32.3"
+#define COREFREQ_VERSION	"1.32.4"
 
 enum {	GenuineIntel,		\
 	Core_Yonah,		\
@@ -330,23 +330,25 @@ enum OFFLINE
 
 typedef struct
 {
-	unsigned int		Q;
-	unsigned long long	R;
-	unsigned long long	Hz;
+	unsigned long long	Q,
+				R,
+				Hz;
 } CLOCK;
 
 #define REL_BCLK(clock, ratio, delta_tsc, interval)			\
-({	/* Compute Divisor					*/	\
-	clock.Q  = delta_tsc / (1000L * interval * ratio);		\
+({	/* Compute Divisor in Interval				*/	\
+	unsigned long long divisor = 1000LLU * ratio * interval;	\
+	/* Compute Quotient					*/	\
+	clock.Q  = delta_tsc / divisor;					\
 	/* Compute Remainder					*/	\
-	clock.R  = delta_tsc % (1000L * interval * ratio);		\
-	clock.R /= (PRECISION * ratio); 				\
+	clock.R  = delta_tsc % divisor;					\
 	/* Compute full Hertz					*/	\
-	clock.Hz = (clock.Q * 1000000L) + (clock.R * PRECISION);	\
+	clock.Hz = (clock.Q * 1000000LLU)				\
+		 + (clock.R * 1000000LLU) / divisor;			\
 })
 
 #define REL_FREQ(max_ratio, this_ratio, clock, interval)		\
-		( ((this_ratio * clock.Q) * 1000L * interval)		\
+		( ((this_ratio * clock.Q) * 1000LLU * interval) 	\
 		+ ((this_ratio * clock.R) / max_ratio))
 
 typedef union {
